// Copyright 2020 Datafuse Labs.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

pub use client_conf::FlightClientConf;
pub use client_conf::FlightClientTlsConfig;
pub use dns_resolver::ConnectionFactory;
pub use dns_resolver::DNSResolver;
pub use flight_token::FlightClaim;
pub use flight_token::FlightToken;

mod client_conf;
mod dns_resolver;
mod flight_token;

#[cfg(test)]
mod dns_resolver_test;
